Index: palm/trunk/INSTALL/test_oceanml_p3d
===================================================================
--- palm/trunk/INSTALL/test_oceanml_p3d	(revision 3291)
+++ palm/trunk/INSTALL/test_oceanml_p3d	(revision 3294)
@@ -19,5 +19,4 @@
     initializing_actions       = 'set_constant_profiles', ! initial conditions
 
-    ocean                      = .TRUE., ! enable ocean modeling
     latitude                   = 55.6,
 
@@ -37,5 +36,4 @@
     bc_s_b                     = 'initial_gradient',
     bc_s_t                     = 'neumann',
-    bc_sa_t                    = 'neumann',
 
     use_top_fluxes             = .T.,
@@ -47,5 +45,4 @@
 
     top_heatflux               = 0.0,
-    top_salinityflux           = 0.0,
 !
 !-- numerics
@@ -75,6 +72,4 @@
 !-- data output
 !-------------------------------------------------------------------------------
-    netcdf_data_format         = 5, ! use NetCDF3
-
     dt_run_control             = 0.0,    ! output interval for run control
 
@@ -83,3 +78,15 @@
 / ! end of runtime parameter namelist
  
+!-------------------------------------------------------------------------------
+!-- OCEAN PARAMETER NAMELIST
+!   Documentation: https://palm.muk.uni-hannover.de/trac/wiki/doc/app/oceanpar
+!-------------------------------------------------------------------------------
+&ocean_parameters
+!
+!-- top boundary condition for salinity
+    bc_sa_t                    = 'neumann',
 
+!   zero salinityflux at ocean surface
+    top_salinityflux           = 0.0,
+
+/ ! end of ocean parameters
Index: palm/trunk/INSTALL/test_oceanml_rc
===================================================================
--- palm/trunk/INSTALL/test_oceanml_rc	(revision 3291)
+++ palm/trunk/INSTALL/test_oceanml_rc	(revision 3294)
@@ -1,10 +1,10 @@
 
  ******************************    --------------------------------------------
- * PALM 4.0  Rev: 2507M       *    ocean - run without 1D - prerun
+ * PALM 5.0  Rev: 3291M       *    ocean - run without 1D - prerun
  ******************************    --------------------------------------------
 
- Date:                 02-10-17    Run:       test_oceanml        
- Time:                 10:50:00    Run-No.:   00
- Run on host:             lcmuk
+ Date:                 01-10-18    Run:       test_oceanml                      
+ Time:                 04:15:16    Run-No.:   00
+ Run on host:              imuk
  Number of PEs:               4    Processor grid (x,y): (   2,   2) calculated
  ------------------------------------------------------------------------------
@@ -13,4 +13,5 @@
  -----------------
 
+ --> Use the Moeng_Wyngaard turbulence closure (LES mode).
  --> Use the boussinesq approximation for the model equations.
  --> Solve perturbation pressure via FFT using temperton-algorithm routines
@@ -34,6 +35,10 @@
  ----------------------------------
 
- Grid length:      dx =      1.250 m    dy =      1.250 m    dz =      1.250 m
+ Grid length:      dx =       1.250 m    dy =       1.250 m
+                dz(1) =       1.250 m
+
  Domain size:       x =     80.000 m     y =     80.000 m  z(u) =    -80.000 m
+
+
 
  Number of gridpoints (x,y,z):  (0:  63, 0:  63, 0:  65)
@@ -114,5 +119,5 @@
 
     1D-Profiles:
-       Output every             ******** s
+       Output every             9999999.90 s
 
 
@@ -141,8 +146,12 @@
  -------------------
 
-    Geograph. latitude  :   phi    = 55.6 degr
+    Geograph. latitude  :   latitude  = 55.6 degr
+    Geograph. longitude :   longitude =  0.0 degr
     Angular velocity    :   omega  = 0.729E-04 rad/s
     Coriolis parameter  :   f      =  0.000120 1/s
                             f*     =  0.000082 1/s
+
+    Day of the year at model start :   day_init      =     172
+    UTC time at model start        :   time_utc_init = 43200.0 s
 
     Gravity             :   g      =  9.8 m/s**2
Index: palm/trunk/SCRIPTS/palmrun
===================================================================
--- palm/trunk/SCRIPTS/palmrun	(revision 3291)
+++ palm/trunk/SCRIPTS/palmrun	(revision 3294)
@@ -27,4 +27,7 @@
 # -----------------
 # $Id$
+# more detailed error message for outdated fileconnection file
+# 
+# 3236 2018-09-10 09:07:06Z raasch
 # warning issued in case of file connection file version mismatch,
 # host_configuration renamed configuration_identifier,
@@ -409,5 +412,6 @@
           printf "\n               working directory, but its revision does not match"
           printf "\n               the revision of the default (trunk) version."
-          printf "\n               You may need to update your connection file!"
+          printf "\n               You may need to update your connection file"
+          printf "\n               \"${working_directory}/.palm.iofiles\" !"
        fi
     fi
Index: palm/trunk/SOURCE/Makefile
===================================================================
--- palm/trunk/SOURCE/Makefile	(revision 3291)
+++ palm/trunk/SOURCE/Makefile	(revision 3294)
@@ -25,4 +25,8 @@
 # -----------------
 # $Id$
+# changes related to modularization of the ocean mode,
+# bugfix: dependency to advec_ws was missed in chemistry_model_mod
+# 
+# 3274 2018-09-24 15:42:55Z knoop
 # Added palm dependency of multi_agent_system_mod, because of mas_last_actions
 # call at the end of palm run
@@ -494,5 +498,4 @@
 	disturb_field.f90 \
 	disturb_heatflux.f90 \
-	eqn_state_seawater.f90 \
 	exchange_horiz_2d.f90 \
 	exchange_horiz.f90 \
@@ -509,9 +512,9 @@
 	init_grid.f90 \
 	init_masks.f90 \
-	init_ocean.f90 \
 	init_pegrid.f90 \
 	init_pt_anomaly.f90 \
 	init_rankine.f90 \
 	init_slope.f90 \
+	init_vertical_profiles.f90 \
 	interaction_droplets_ptq.f90 \
 	land_surface_model_mod.f90 \
@@ -548,4 +551,5 @@
 	netcdf_data_input_mod.f90 \
 	netcdf_interface_mod.f90 \
+	ocean_mod.f90 \
 	outflow_turbulence.f90 \
 	package_parin.f90 \
@@ -707,4 +711,5 @@
 	mod_kinds.o \
 	modules.o \
+	ocean_mod.o \
 	radiation_model_mod.o \
 	turbulence_closure_mod.o \
@@ -753,4 +758,5 @@
 	chemistry_model_mod.o \
 	gust_mod.o \
+	init_vertical_profiles.o \
 	land_surface_model_mod.o \
 	large_scale_forcing_nudging_mod.o \
@@ -760,4 +766,5 @@
 	netcdf_data_input_mod.o \
 	netcdf_interface_mod.o \
+	ocean_mod.o \
 	plant_canopy_model_mod.o \
 	pmc_interface_mod.o \
@@ -772,4 +779,5 @@
 	wind_turbine_model_mod.o
 chemistry_model_mod.o: \
+	advec_ws.o \
 	chem_gasphase_mod.o \
 	chem_modules.o \
@@ -867,4 +875,5 @@
 	modules.o \
 	netcdf_interface_mod.o \
+	ocean_mod.o \
 	radiation_model_mod.o \
 	surface_mod.o \
@@ -882,4 +891,5 @@
 	modules.o \
 	netcdf_interface_mod.o \
+	ocean_mod.o \
 	turbulence_closure_mod.o \
 	urban_surface_mod.o
@@ -914,8 +924,4 @@
 	modules.o \
 	random_generator_parallel_mod.o \
-	surface_mod.o
-eqn_state_seawater.o: \
-	mod_kinds.o \
-	modules.o \
 	surface_mod.o
 exchange_horiz.o: \
@@ -963,4 +969,5 @@
 	modules.o \
 	netcdf_interface_mod.o \
+	ocean_mod.o \
 	plant_canopy_model_mod.o \
 	pmc_handle_communicator_mod.o \
@@ -993,4 +1000,5 @@
 	netcdf_data_input_mod.o \
 	netcdf_interface_mod.o \
+	ocean_mod.o \
 	plant_canopy_model_mod.o \
 	pmc_interface_mod.o \
@@ -1030,9 +1038,4 @@
 	modules.o \
 	netcdf_interface_mod.o
-init_ocean.o: \
-	basic_constants_and_equations_mod.o \
-	eqn_state_seawater.o \
-	mod_kinds.o \
-	modules.o
 init_pegrid.o: \
 	mod_kinds.o \
@@ -1052,4 +1055,7 @@
 	mod_kinds.o \
 	modules.o
+init_vertical_profiles.o: \
+	modules.o \
+	mod_kinds.o
 interaction_droplets_ptq.o: \
 	basic_constants_and_equations_mod.o \
@@ -1238,4 +1244,5 @@
 	mod_kinds.o \
 	modules.o \
+	ocean_mod.o \
 	radiation_model_mod.o \
 	spectra_mod.o \
@@ -1243,4 +1250,15 @@
 	urban_surface_mod.o \
 	uv_exposure_model_mod.o
+ocean_mod.o: \
+ advec_s_pw.o \
+	advec_s_up.o \
+	advec_ws.o \
+	basic_constants_and_equations_mod.o \
+	diffusion_s.o \
+	init_vertical_profiles.o \
+	mod_kinds.o \
+	modules.o \
+	pmc_interface_mod.o \
+	user_actions.o
 outflow_turbulence.o: \
 	cpulog_mod.o \
@@ -1278,4 +1296,5 @@
 	multi_agent_system_mod.o \
 	netcdf_interface_mod.o \
+	ocean_mod.o \
 	plant_canopy_model_mod.o \
 	pmc_interface_mod.o \
@@ -1387,5 +1406,4 @@
 	diffusion_v.o \
 	diffusion_w.o \
-	eqn_state_seawater.o \
 	large_scale_forcing_nudging_mod.o \
 	mod_kinds.o \
@@ -1393,4 +1411,5 @@
 	modules.o \
 	modules.o \
+	ocean_mod.o \
 	plant_canopy_model_mod.o \
 	radiation_model_mod.o \
@@ -1508,4 +1527,5 @@
 	mod_kinds.o \
 	modules.o \
+ ocean_mod.o \
 	pmc_interface_mod.o \
 	turbulence_closure_mod.o \
@@ -1538,4 +1558,5 @@
 	modules.o \
 	multi_agent_system_mod.o \
+ ocean_mod.o \
 	pmc_interface_mod.o \
 	prognostic_equations.o \
@@ -1595,4 +1616,5 @@
 	mod_particle_attributes.o \
 	modules.o \
+ ocean_mod.o \
 	plant_canopy_model_mod.o \
 	pmc_interface_mod.o \
@@ -1785,4 +1807,5 @@
 	modules.o \
 	netcdf_interface_mod.o \
+	ocean_mod.o \
 	radiation_model_mod.o \
 	random_function_mod.o \
Index: palm/trunk/SOURCE/advec_ws.f90
===================================================================
--- palm/trunk/SOURCE/advec_ws.f90	(revision 3291)
+++ palm/trunk/SOURCE/advec_ws.f90	(revision 3294)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! ocean renamed ocean_mode
+! 
+! 3274 2018-09-24 15:42:55Z knoop
 ! Modularization of all bulk cloud physics code components
 ! 
@@ -293,5 +296,5 @@
 
        USE control_parameters,                                                 &
-           ONLY:  humidity, loop_optimization, passive_scalar, ocean,          &
+           ONLY:  humidity, loop_optimization, passive_scalar, ocean_mode,     &
                   rans_tke_e, ws_scheme_mom, ws_scheme_sca
 
@@ -369,5 +372,5 @@
           ENDIF
 
-          IF ( ocean )  THEN
+          IF ( ocean_mode )  THEN
              ALLOCATE( sums_wssas_ws_l(nzb:nzt+1,0:threads_per_task-1) )
              sums_wssas_ws_l = 0.0_wp
@@ -454,5 +457,5 @@
              ENDIF
 
-             IF ( ocean )  THEN
+             IF ( ocean_mode )  THEN
                 ALLOCATE( flux_s_sa(nzb+1:nzt,0:threads_per_task-1),           &
                           diss_s_sa(nzb+1:nzt,0:threads_per_task-1) )
@@ -1084,5 +1087,6 @@
     
        USE control_parameters,                                                 &
-           ONLY:  humidity, passive_scalar, ocean, ws_scheme_mom, ws_scheme_sca
+           ONLY:  humidity, passive_scalar, ocean_mode, ws_scheme_mom,         &
+                  ws_scheme_sca
 
        USE kinds
@@ -1123,5 +1127,5 @@
              sums_wsnrs_ws_l = 0.0_wp
           ENDIF
-          IF ( ocean )  sums_wssas_ws_l = 0.0_wp
+          IF ( ocean_mode )  sums_wssas_ws_l = 0.0_wp
 
        ENDIF
Index: palm/trunk/SOURCE/average_3d_data.f90
===================================================================
--- palm/trunk/SOURCE/average_3d_data.f90	(revision 3291)
+++ palm/trunk/SOURCE/average_3d_data.f90	(revision 3294)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! changes concerning modularization of ocean option
+! 
+! 3274 2018-09-24 15:42:55Z knoop
 ! Modularization of all bulk cloud physics code components
 ! 
@@ -149,5 +152,5 @@
     USE control_parameters,                                                    &
         ONLY:  air_chemistry, average_count_3d, doav, doav_n, land_surface,    &
-               urban_surface, varnamelength
+               ocean_mode, urban_surface, varnamelength
 
     USE cpulog,                                                                &
@@ -165,4 +168,7 @@
         ONLY:  lsm_3d_data_averaging
 
+    USE ocean_mod,                                                             &
+        ONLY:  ocean_3d_data_averaging
+
     USE radiation_model_mod,                                                   &
         ONLY:  radiation, radiation_3d_data_averaging
@@ -179,8 +185,8 @@
     IMPLICIT NONE
 
-    INTEGER(iwp) ::  i  !< running index
-    INTEGER(iwp) ::  ii !< running index
-    INTEGER(iwp) ::  j  !< running index
-    INTEGER(iwp) ::  k  !< running index
+    INTEGER(iwp) ::  i   !< loop index
+    INTEGER(iwp) ::  ii  !< loop index
+    INTEGER(iwp) ::  j   !< loop index
+    INTEGER(iwp) ::  k   !< loop index
 
     CHARACTER (LEN=varnamelength) ::  trimvar  !< TRIM of output-variable string
@@ -392,15 +398,4 @@
              ENDIF
 
-          CASE ( 'rho_ocean' )
-             IF ( ALLOCATED( rho_ocean_av ) ) THEN
-                DO  i = nxlg, nxrg
-                   DO  j = nysg, nyng
-                      DO  k = nzb, nzt+1
-                         rho_ocean_av(k,j,i) = rho_ocean_av(k,j,i) / REAL( average_count_3d, KIND=wp )
-                      ENDDO
-                   ENDDO
-                ENDDO
-             ENDIF
-
           CASE ( 's' )
              IF ( ALLOCATED( s_av ) ) THEN
@@ -414,15 +409,4 @@
              ENDIF
 
-          CASE ( 'sa' )
-             IF ( ALLOCATED( sa_av ) ) THEN
-                DO  i = nxlg, nxrg
-                   DO  j = nysg, nyng
-                      DO  k = nzb, nzt+1
-                         sa_av(k,j,i) = sa_av(k,j,i) / REAL( average_count_3d, KIND=wp )
-                      ENDDO
-                   ENDDO
-                ENDDO
-             ENDIF
-
          CASE ( 'shf*' )
              IF ( ALLOCATED( shf_av ) ) THEN
@@ -549,40 +533,39 @@
              ENDIF
 
+          CASE ( 'usm_output' )
 !             
-!--       Block of urban surface model outputs   
-          CASE ( 'usm_output' )
+!--          Block of urban surface model outputs
              CALL usm_average_3d_data( 'average', doav(ii) )
 
           CASE DEFAULT
 !
-!--          Turbulence closure module
-             CALL tcm_3d_data_averaging( 'average', doav(ii) )
-!
-!--          microphysics module quantities
+!--          Averaging of data from other modules
+             IF ( air_chemistry )  THEN
+                CALL chem_3d_data_averaging( 'average', doav(ii) )
+             ENDIF
+
              IF ( bulk_cloud_model )  THEN
                 CALL bcm_3d_data_averaging( 'average', doav(ii) )
              ENDIF
-!
-!--          Land surface quantity
+
+             IF ( gust_module_enabled )  THEN
+                CALL gust_3d_data_averaging( 'average', doav(ii) )
+             ENDIF
+
              IF ( land_surface )  THEN
                 CALL lsm_3d_data_averaging( 'average', doav(ii) )
              ENDIF
-!
-!--          Radiation quantity
+
+             IF ( ocean_mode )  THEN
+                CALL ocean_3d_data_averaging( 'average', doav(ii) )
+             ENDIF
+
              IF ( radiation )  THEN
                 CALL radiation_3d_data_averaging( 'average', doav(ii) )
              ENDIF
-!
-!--          Gust module quantities
-             IF ( gust_module_enabled )  THEN
-                CALL gust_3d_data_averaging( 'average', doav(ii) )
-             ENDIF
-!
-!--          Chemistry quantity
-             IF ( air_chemistry )  THEN
-                CALL chem_3d_data_averaging( 'average', doav(ii) )
-             ENDIF
-!
-!--          User-defined quantity
+
+             CALL tcm_3d_data_averaging( 'average', doav(ii) )
+!
+!--          User-defined quantities
              CALL user_3d_data_averaging( 'average', doav(ii) )
 
Index: palm/trunk/SOURCE/boundary_conds.f90
===================================================================
--- palm/trunk/SOURCE/boundary_conds.f90	(revision 3291)
+++ palm/trunk/SOURCE/boundary_conds.f90	(revision 3294)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! changes concerning modularization of ocean option
+! 
+! 3274 2018-09-24 15:42:55Z knoop
 ! Modularization of all bulk cloud physics code components
 ! 
@@ -203,4 +206,7 @@
         ONLY:  kappa
 
+    USE bulk_cloud_model_mod,                                                  &
+        ONLY: bulk_cloud_model, microphysics_morrison, microphysics_seifert
+
     USE chemistry_model_mod,                                                   &
         ONLY:  chem_boundary_conds 
@@ -212,8 +218,7 @@
                child_domain, constant_diffusion, coupling_mode, &
                dt_3d, humidity, ibc_pt_b, ibc_pt_t, ibc_q_b, ibc_q_t, ibc_s_b, &
-               ibc_s_t,ibc_sa_t, ibc_uv_b, ibc_uv_t,                           &
-               intermediate_timestep_count,                                    &
-               nesting_offline, nudging,                                       &
-               ocean, passive_scalar, rans_mode, rans_tke_e, tsc, use_cmax
+               ibc_s_t, ibc_uv_b, ibc_uv_t,                           &
+               intermediate_timestep_count, nesting_offline, nudging,          &
+               ocean_mode, passive_scalar, rans_mode, rans_tke_e, tsc, use_cmax
 
     USE grid_variables,                                                        &
@@ -221,11 +226,10 @@
 
     USE indices,                                                               &
-        ONLY:  nx, nxl, nxlg, nxr, nxrg, ny, nyn, nyng, nys, nysg,             &
-               nzb, nzt
+        ONLY:  nx, nxl, nxlg, nxr, nxrg, ny, nyn, nyng, nys, nysg, nzb, nzt
 
     USE kinds
 
-    USE bulk_cloud_model_mod,                                                  &
-        ONLY: bulk_cloud_model, microphysics_morrison, microphysics_seifert
+    USE ocean_mod,                                                             &
+        ONLY:  ibc_sa_t
 
     USE pegrid
@@ -529,5 +533,5 @@
 !
 !-- Boundary conditions for salinity
-    IF ( ocean )  THEN
+    IF ( ocean_mode )  THEN
 !
 !--    Bottom boundary: Neumann condition because salinity flux is always
Index: palm/trunk/SOURCE/buoyancy.f90
===================================================================
--- palm/trunk/SOURCE/buoyancy.f90	(revision 3291)
+++ palm/trunk/SOURCE/buoyancy.f90	(revision 3294)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! module use statements moved to global declaration section
+! 
+! 3274 2018-09-24 15:42:55Z knoop
 ! Modularization of all bulk cloud physics code components
 ! 
@@ -53,5 +56,4 @@
 ! 1850 2016-04-08 13:29:27Z maronga
 ! Module renamed
-! 
 ! 
 ! 1682 2015-10-07 23:56:08Z knoop
@@ -121,4 +123,13 @@
         ONLY:  g
 
+    USE arrays_3d,                                                             &
+        ONLY:  pt, pt_slope_ref, ref_state, tend
+
+    USE control_parameters,                                                    &
+        ONLY:  atmos_ocean_sign, cos_alpha_surface, message_string, pt_surface,&
+               sin_alpha_surface, sloping_surface
+
+    USE kinds
+
     PRIVATE
     PUBLIC buoyancy
@@ -139,18 +150,7 @@
     SUBROUTINE buoyancy( var, wind_component )
 
-       USE arrays_3d,                                                          &
-           ONLY:  pt, pt_slope_ref, ref_state, tend
-
-       USE control_parameters,                                                 &
-           ONLY:  atmos_ocean_sign, cos_alpha_surface, message_string,         &
-                  pt_surface, sin_alpha_surface, sloping_surface
-
        USE indices,                                                            &
            ONLY:  nxl, nxlg, nxlu, nxr, nxrg, nyn, nyng, nys, nysg, nzb,       &
                   nzt, wall_flags_0
-
-       USE kinds
-
-       USE pegrid
 
 
@@ -245,18 +245,7 @@
     SUBROUTINE buoyancy_ij( i, j, var, wind_component )
 
-       USE arrays_3d,                                                          &
-           ONLY:  pt, pt_slope_ref, ref_state, tend
-
-       USE control_parameters,                                                 &
-           ONLY:  atmos_ocean_sign, cos_alpha_surface, message_string,         &
-                  pt_surface, sin_alpha_surface, sloping_surface
 
        USE indices,                                                            &
            ONLY:  nxlg, nxrg, nyng, nysg, nzb, nzt, wall_flags_0
-
-       USE kinds
-
-       USE pegrid
-
 
        IMPLICIT NONE
